# Allow target distro to be overridden using: rpmbuild --define "distro fc42"
# Valid values for distro are: fc19 fc20 fc21 fc22 fc23 fc24 fc25 fc26 fc27 fc28 fc29 fc30 fc31 fc32 fc33 fc34 fc35 fc36 fc37 fc38 fc39 fc40 fc41 fc42 fc43 fc44 devel rhel7 rhel8 rhel9 rhel10

# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# For the special case of Rawhide, use "devel" as the distro
%if "%{__distname}" == "Rawhide"
%global __distvers %{nil}
%global __distinit devel
%endif
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Set distribution booleans
%{!?distro: %global distro %{__distinit}%{__distvers}}
%global rhel7	%(if [ "%{distro}" == "rhel7"	]; then echo 1; else echo 0; fi)
%global rhel8	%(if [ "%{distro}" == "rhel8"	]; then echo 1; else echo 0; fi)
%global rhel9	%(if [ "%{distro}" == "rhel9"	]; then echo 1; else echo 0; fi)
%global rhel10	%(if [ "%{distro}" == "rhel10"	]; then echo 1; else echo 0; fi)
%global fc19	%(if [ "%{distro}" == "fc19"	]; then echo 1; else echo 0; fi)
%global fc20	%(if [ "%{distro}" == "fc20"	]; then echo 1; else echo 0; fi)
%global fc21	%(if [ "%{distro}" == "fc21"	]; then echo 1; else echo 0; fi)
%global fc22	%(if [ "%{distro}" == "fc22"	]; then echo 1; else echo 0; fi)
%global fc23	%(if [ "%{distro}" == "fc23"	]; then echo 1; else echo 0; fi)
%global fc24	%(if [ "%{distro}" == "fc24"	]; then echo 1; else echo 0; fi)
%global fc25	%(if [ "%{distro}" == "fc25"	]; then echo 1; else echo 0; fi)
%global fc26	%(if [ "%{distro}" == "fc26"	]; then echo 1; else echo 0; fi)
%global fc27	%(if [ "%{distro}" == "fc27"	]; then echo 1; else echo 0; fi)
%global fc28	%(if [ "%{distro}" == "fc28"	]; then echo 1; else echo 0; fi)
%global fc29	%(if [ "%{distro}" == "fc29"	]; then echo 1; else echo 0; fi)
%global fc30	%(if [ "%{distro}" == "fc30"	]; then echo 1; else echo 0; fi)
%global fc31	%(if [ "%{distro}" == "fc31"	]; then echo 1; else echo 0; fi)
%global fc32	%(if [ "%{distro}" == "fc32"	]; then echo 1; else echo 0; fi)
%global fc33	%(if [ "%{distro}" == "fc33"	]; then echo 1; else echo 0; fi)
%global fc34	%(if [ "%{distro}" == "fc34"	]; then echo 1; else echo 0; fi)
%global fc35	%(if [ "%{distro}" == "fc35"	]; then echo 1; else echo 0; fi)
%global fc36	%(if [ "%{distro}" == "fc36"	]; then echo 1; else echo 0; fi)
%global fc37	%(if [ "%{distro}" == "fc37"	]; then echo 1; else echo 0; fi)
%global fc38	%(if [ "%{distro}" == "fc38"	]; then echo 1; else echo 0; fi)
%global fc39	%(if [ "%{distro}" == "fc39"	]; then echo 1; else echo 0; fi)
%global fc40	%(if [ "%{distro}" == "fc40"	]; then echo 1; else echo 0; fi)
%global fc41	%(if [ "%{distro}" == "fc41"	]; then echo 1; else echo 0; fi)
%global fc42	%(if [ "%{distro}" == "fc42"	]; then echo 1; else echo 0; fi)
%global fc43	%(if [ "%{distro}" == "fc43"	]; then echo 1; else echo 0; fi)
%global fc44	%(if [ "%{distro}" == "fc44"	]; then echo 1; else echo 0; fi)
%global devel	%(if [ "%{distro}" == "devel"	]; then echo 1; else echo 0; fi)

# Require dnf rather than yum from Fedora 22 onwards
%global prefer_dnf %([ "(" "%{__distinit}" == "fc" -a %{__distvers} -gt 21 ")" -o "(" "%{__distinit}" == "rhel" -a %{__distvers} -gt 7 ")" ] && echo 1 || echo 0)

# Our development repositories can be in one of three states:
# 1. Stable release
#    At the time of a stable release and until the next branch point:
#    - stable repo will contain only packages for fedora<n>
#    - branched repo will not exist
#    - development repo will contain a mix of packages for fedora<n> and fedora<n+1>
# 2. Branch point
#    At the time of branching from Rawhide and until the branched rebuild is complete:
#    - stable repo will contain only packages for fedora<n>
#    - branched repo will contain a mix of packages for fedora<n> and fedora<n+1>
#    - development repo will contain a mix of packages for fedora<n>, fedora<n+1> and fedora<n+2>
# 3. Rebuild complete
#    At completion of rebuild for branched release, until the stable release:
#    - stable repo will contain only packages for fedora<n>
#    - branched repo will contain only packages for fedora<n+1>
#    - development repo will contain a mix of packages for fedora<n+1> and fedora<n+2>
%global devel_repo_state stable_release
%global stable_release 41
%global branched_release 42
%global rawhide_release 42
%global next_rawhide_release 43
%if %{devel}
%global this_release %{rawhide_release}
%global this_is_fedora 1
%else
%global this_release %{__distvers}
%if "%{__distinit}" == "fc"
%global this_is_fedora 1
%else
%global this_is_fedora 0
%endif
%endif

Summary:	Release file and package configuration for city-fan.org repository
Name:		city-fan.org-release
Version:	3
Release:	15.%{distro}
License:	GPL-2.0-or-later
URL:		http://www.city-fan.org/ftp/contrib/yum-repo/
Source0:	GPL
Source1:	RPM-GPG-KEY-city-fan.org
Source2:	city-fan.org.repo
Source3:	city-fan.org-development.repo

Source7:	RPM-GPG-KEY-city-fan.org-rhel-7
Source8:	RPM-GPG-KEY-city-fan.org-rhel-8
Source9:	RPM-GPG-KEY-city-fan.org-rhel-9
Source10:	RPM-GPG-KEY-city-fan.org-rhel-10
Source19:	RPM-GPG-KEY-city-fan.org-fedora-19
Source20:	RPM-GPG-KEY-city-fan.org-fedora-20
Source21:	RPM-GPG-KEY-city-fan.org-fedora-21
Source22:	RPM-GPG-KEY-city-fan.org-fedora-22
Source23:	RPM-GPG-KEY-city-fan.org-fedora-23
Source24:	RPM-GPG-KEY-city-fan.org-fedora-24
Source25:	RPM-GPG-KEY-city-fan.org-fedora-25
Source26:	RPM-GPG-KEY-city-fan.org-fedora-26
Source27:	RPM-GPG-KEY-city-fan.org-fedora-27
Source28:	RPM-GPG-KEY-city-fan.org-fedora-28
Source29:	RPM-GPG-KEY-city-fan.org-fedora-29
Source30:	RPM-GPG-KEY-city-fan.org-fedora-30
Source31:	RPM-GPG-KEY-city-fan.org-fedora-31
Source32:	RPM-GPG-KEY-city-fan.org-fedora-32
Source33:	RPM-GPG-KEY-city-fan.org-fedora-33
Source34:	RPM-GPG-KEY-city-fan.org-fedora-34
Source35:	RPM-GPG-KEY-city-fan.org-fedora-35
Source36:	RPM-GPG-KEY-city-fan.org-fedora-36
Source37:	RPM-GPG-KEY-city-fan.org-fedora-37
Source38:	RPM-GPG-KEY-city-fan.org-fedora-38
Source39:	RPM-GPG-KEY-city-fan.org-fedora-39
Source40:	RPM-GPG-KEY-city-fan.org-fedora-40
Source41:	RPM-GPG-KEY-city-fan.org-fedora-41
Source42:	RPM-GPG-KEY-city-fan.org-fedora-42

%if %{prefer_dnf}
Requires:	dnf
%else
Requires:	yum >= 2.2.1
%endif
BuildArch:	noarch

%description
city-fan.org release file. This package also contains repo configuration to
use the city-fan.org provided rpm packages, as well as the public gpg keys
used to sign them.

You will still need to manually enable the city-fan.org repository in your
package manager after installing this package.

%prep
%setup -c -T
cp -a %{SOURCE0} %{SOURCE1} .
%if %{devel}
cp -a %{SOURCE3} city-fan.org.repo
%else
cp -a %{SOURCE2} city-fan.org.repo
%endif
%if %{rhel7} || %{rhel8} || %{rhel9} || %{rhel10}
sed -i -e 's@\([-/]\)fc\$@\1rhel$@' city-fan.org.repo
sed -i -e 's@Fedora@Red Hat Enterprise Linux (and clones)@' city-fan.org.repo
%endif

# Work out which GPG keys we need for any particular release package
# Anything prior to Fedora 38 will need to handle packages signed with the legacy key
%if ! %{this_is_fedora}
# RHEL
%if %{rhel7}
KEYLIST="file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-rhel-7"
%endif
%if %{rhel8}
KEYLIST="file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-rhel-8"
%endif
%if %{rhel9}
KEYLIST="file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-rhel-9"
%endif
%if %{rhel10}
KEYLIST="file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-rhel-10"
%endif
%else
# Fedora
%if %{this_release} <= 37
KEYLIST="file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org "
%else
KEYLIST=""
%endif
%if %{this_release} <= %{stable_release}
# Stable Fedora release
KEYLIST="${KEYLIST}file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-\$releasever"
%else
# Branched or development
%if "%{devel_repo_state}" == "stable_release"
# Include key for next rawhide release so that immediately after branching the packages in the development repo
# that are signed with the next rawhide key will be recognised as being valid
KEYLIST="${KEYLIST}file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{stable_release} file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{rawhide_release} file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{next_rawhide_release}"
%endif
%if "%{devel_repo_state}" == "branch_point"
%if %{this_release} == %{branched_release}
KEYLIST="${KEYLIST}file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{stable_release} file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{branched_release}"
%else
KEYLIST="${KEYLIST}file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{stable_release} file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{branched_release} file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{rawhide_release}"
%endif
%endif
%if "%{devel_repo_state}" == "rebuild_complete"
%if %{this_release} == %{branched_release}
KEYLIST="${KEYLIST}file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{branched_release}"
%else
KEYLIST="${KEYLIST}file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{branched_release} file:///etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org-fedora-%{rawhide_release}"
%endif
%endif
%endif
%endif
sed -i -e "s|KEYLIST|${KEYLIST}|" city-fan.org.repo

%build

%install
# Install gpg keys
install -m 0755 -d %{buildroot}%{_sysconfdir}/pki/rpm-gpg
install -m 0644 RPM-GPG-KEY-city-fan.org %{buildroot}%{_sysconfdir}/pki/rpm-gpg/
install -m 0644 \
	%{SOURCE7} \
	%{SOURCE8} \
	%{SOURCE9} \
	%{SOURCE10} \
	%{SOURCE19} \
	%{SOURCE20} \
	%{SOURCE21} \
	%{SOURCE22} \
	%{SOURCE23} \
	%{SOURCE24} \
	%{SOURCE25} \
	%{SOURCE26} \
	%{SOURCE27} \
	%{SOURCE28} \
	%{SOURCE29} \
	%{SOURCE30} \
	%{SOURCE31} \
	%{SOURCE32} \
	%{SOURCE33} \
	%{SOURCE34} \
	%{SOURCE35} \
	%{SOURCE36} \
	%{SOURCE37} \
	%{SOURCE38} \
	%{SOURCE39} \
	%{SOURCE40} \
	%{SOURCE41} \
	%{SOURCE42} \
	%{buildroot}%{_sysconfdir}/pki/rpm-gpg/

# Install repo files
install -D -m 0644 city-fan.org.repo \
	%{buildroot}%{_sysconfdir}/yum.repos.d/city-fan.org.repo

%files
%doc GPL
%dir /etc/pki/rpm-gpg
/etc/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org*
%config(noreplace) %{_sysconfdir}/yum.repos.d/city-fan.org.repo

%changelog
* Wed Oct 30 2024 Paul Howarth <paul@city-fan.org> - 3-15
- Fedora 41 rebuild complete and released

* Fri Aug 16 2024 Paul Howarth <paul@city-fan.org> - 3-14
- Add support for EL-10

* Fri Aug 16 2024 Paul Howarth <paul@city-fan.org> - 3-13
- Fedora 41 branched

* Mon May 27 2024 Paul Howarth <paul@city-fan.org> - 3-12
- Fedora 40 rebuild complete and released

* Mon Feb 19 2024 Paul Howarth <paul@city-fan.org> - 3-11
- Fedora 40 branched

* Wed Nov  8 2023 Paul Howarth <paul@city-fan.org> - 3-10
- Fedora 39 rebuild complete and released

* Thu Aug 10 2023 Paul Howarth <paul@city-fan.org> - 3-9
- Fedora 39 branched
- Add package signing keys for Fedora 41 and Fedora 42

* Sun Apr 16 2023 Paul Howarth <paul@city-fan.org> - 3-8
- Fedora 38 released

* Thu Mar 30 2023 Paul Howarth <paul@city-fan.org> - 3-7
- Fedora 38 rebuild complete, no inherited Fedora 37 packages

* Sat Feb 11 2023 Paul Howarth <paul@city-fan.org> - 3-6
- Fedora 38 branched
- Use SPDX-format license tag

* Wed Nov 16 2022 Paul Howarth <paul@city-fan.org> - 3-5
- Fedora 37 released

* Tue Sep 27 2022 Paul Howarth <paul@city-fan.org> - 3-4
- Fedora 37 rebuild complete, no inherited Fedora 36 packages

* Sun Aug 14 2022 Paul Howarth <paul@city-fan.org> - 3-3
- Fedora 37 branched

* Fri Aug  5 2022 Paul Howarth <paul@city-fan.org> - 3-2
- In the devel release package during the stable release phase (i.e. prior to
  branching), include key for next rawhide release so that immediately after
  branching the packages in the development repo that are signed with the next
  Rawhide key will be recognised as being valid

* Wed Aug  3 2022 Paul Howarth <paul@city-fan.org> - 3-1
- Switch to per-release GPG keys

* Wed Dec  8 2021 Paul Howarth <paul@city-fan.org> - 2-2
- Drop support for EOL distributions prior to Fedora 19
- Add support for EL-9
- Fix dist tags for Alma, Rocky and CentOS Stream

* Thu Feb  1 2018 Paul Howarth <paul@city-fan.org> - 2-1
- Don't enable the repository by default
- Drop support for EOL distributions prior to Fedora 13
- Support Fedora releases up to 36

* Fri Jul  3 2015 Paul Howarth <paul@city-fan.org> - 1-13
- Require dnf rather than yum from Fedora 22 onwards
- Support Fedora releases up to 28

* Fri Sep 21 2012 Paul Howarth <paul@city-fan.org> - 1-12
- Add debuginfo and source repositories
- Support Fedora releases up to 24
- Merge the regular and development repo configurations and ship only the
  former, even on Rawhide

* Fri Jul 29 2011 Paul Howarth <paul@city-fan.org> - 1-10
- Update GPLv2 text for FSF address change
- Fix dist tag for CentOS 6 and Scientific Linux
- Nobody else likes macros for commands

* Fri Feb 11 2011 Paul Howarth <paul@city-fan.org> - 1-9
- Support Fedora releases up to 20

* Mon Jun  8 2009 Paul Howarth <paul@city-fan.org> - 1-8
- Use setup macro in %%prep to run in a subdir

* Tue May 19 2009 Paul Howarth <paul@city-fan.org> - 1-7
- Define macros in global context
- Only refer to "Fedora Core" for releases prior to Fedora 7

* Fri Mar 23 2007 Paul Howarth <paul@city-fan.org> - 1-6
- Add CentOS 5 support and look forward to future releases
- Add empty %%build section

* Mon Jan  8 2007 Paul Howarth <paul@city-fan.org> - 1-5
- Add CentOS 4 support (same as FC3)

* Tue Oct 31 2006 Paul Howarth <paul@city-fan.org> - 1-4
- Add Fedora Core 6 and Rawhide support
- Include architecture in baseurls

* Tue Mar 21 2006 Paul Howarth <paul@city-fan.org> - 1-3
- Add Fedora Core 5 support
- Update distribution-detection code
- Remove buildroot unconditionally in %%clean and %%install

* Thu Jul 14 2005 Paul Howarth <paul@city-fan.org> - 1-2
- Use gpgkey= in city-fan.org.repo and require yum ≥ 2.2.1
- Don't auto-import GPG key in %%post
- Make fc3 and fc4 specific versions of package (different gpg key locations)

* Mon Nov 15 2004 Paul Howarth <paul@city-fan.org> - 1-1
- Initial RPM release, inspired by fedora-release
